#ifndef ARDPRINTF
#define ARDPRINTF
#define ARDBUFFER 16
#include <stdarg.h>
#include <Arduino.h>

int ardprintf(char *str, ...)
{
  int i, count=0, j=0, flag=0;
  char temp[ARDBUFFER+1];
  for(i=0; str[i]!='\0';i++)  if(str[i]=='%')  count++;

  va_list argv;
  va_start(argv, count);
  for(i=0,j=0; str[i]!='\0';i++)
  {
    if(str[i]=='%')
    {
      temp[j] = '\0';
      Serial.print(temp);
      j=0;
      temp[0] = '\0';

      switch(str[++i])
      {
        case 'd': Serial.print(va_arg(argv, int));
                  break;
        case 'l': Serial.print(va_arg(argv, long));
                  break;
        case 'f': Serial.print(va_arg(argv, double));
                  break;
        case 'c': Serial.print((char)va_arg(argv, int));
                  break;
        case 's': Serial.print(va_arg(argv, char *));
                  break;
        default:  ;
      };
    }
    else 
    {
      temp[j] = str[i];
      j = (j+1)%ARDBUFFER;
      if(j==0) 
      {
        temp[ARDBUFFER] = '\0';
        Serial.print(temp);
        temp[0]='\0';
      }
    }
  };
  Serial.println();
  return count + 1;
}
#undef ARDBUFFER
#endif

#define OUTPUT_PIN 50 

void setup() {
  pinMode(OUTPUT_PIN, OUTPUT);
  pinMode(40, INPUT);
  pinMode(41, INPUT);
  Serial.begin(250000);
  digitalWrite(13, 0); 
}

int thisCycle = 0;
double msAvg = 0, msAvgCount = 0;
double timeOptoMsAvg = 0, timeOptoMsCnt = 0;

void loop() {

  thisCycle++;
  
  float voltage;
  int timeOpto;
  int sensorValue;
  double timeOptoMs;

  digitalWrite(OUTPUT_PIN, 0);
 
  for(int d = 0; d < 50; d++)
  {
    do {
    sensorValue = analogRead(A1);
    voltage = sensorValue * (5.0 / 1023.0);
    } while(voltage > 1.0); //1.0-3.0, 3.0 if you have a noisy system
    delay(10);
  }

  delay(random(200, 400));
  
  int timeStart = micros();

  digitalWrite(OUTPUT_PIN, 1); 
  
  timeDisplayMs = (micros() - timeStart);
  timeDisplayMs = timeDisplayMs/1000;
  timeDisplayMsAvg += timeDisplayMs;
  timeDisplayMsCnt++;

  do {
    sensorValue = analogRead(A1);
    voltage = sensorValue * (5.0 / 1023.0);
    //ardprintf("voltage: %f \n", voltage);
  } while(voltage < 1.3);


  timeOptoMs = (micros() - timeStart);
  timeOptoMs = timeOptoMs/1000;

  timeOptoMsAvg += timeOptoMs;
  timeOptoMsCnt++;
  
  ardprintf("Take\t%d\tTime\t%d\tOpto\t%f\tAvg\t%f", thisCycle, millis(), timeOptoMs, timeOptoMsAvg/timeOptoMsCnt);
}
